Package org.apache.lucene.index

## Class FilterLeafReader

- java.lang.Object
- - org.apache.lucene.index.IndexReader
  - - org.apache.lucene.index.LeafReader
    - - org.apache.lucene.index.FilterLeafReader

- All Implemented Interfaces:
    `Closeable`, `AutoCloseable`
  Direct Known Subclasses:
    `ExitableDirectoryReader.ExitableFilterAtomicReader`

      public abstract class FilterLeafReader
      extends LeafReader

  A `FilterLeafReader` contains another LeafReader, which it uses as its basic source of data, possibly transforming the data along the way or providing additional functionality. The class `FilterLeafReader` itself simply implements all abstract methods of `IndexReader` with versions that pass all requests to the contained index reader. Subclasses of `FilterLeafReader` may further override some of these methods and may also provide additional methods and fields.

  NOTE: If you override `getLiveDocs()`, you will likely need to override `numDocs()` as well and vice-versa.

  NOTE: If this `FilterLeafReader` does not change the content the contained reader, you could consider delegating calls to `LeafReader.getCoreCacheHelper()` and `IndexReader.getReaderCacheHelper()`.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `FilterLeafReader.FilterFields` | Base class for filtering `Fields` implementations.
    `static class` | `FilterLeafReader.FilterPostingsEnum` | Base class for filtering `PostingsEnum` implementations.
    `static class` | `FilterLeafReader.FilterTerms` | Base class for filtering `Terms` implementations.
    `static class` | `FilterLeafReader.FilterTermsEnum` | Base class for filtering `TermsEnum` implementations.

    - ### Nested classes/interfaces inherited from class org.apache.lucene.index.IndexReader

      `IndexReader.CacheHelper, IndexReader.CacheKey, IndexReader.ClosedListener`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected LeafReader` | `in` | The underlying LeafReader.

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `FilterLeafReader​(LeafReader in)` | Construct a FilterLeafReader based on the specified base reader.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `checkIntegrity()` | Checks consistency of this reader.
    `protected void` | `doClose()` | Implements close.
    `void` | `document​(int docID, StoredFieldVisitor visitor)` | Expert: visits the fields of a stored document, for custom processing/loading of each field.
    `BinaryDocValues` | `getBinaryDocValues​(String field)` | Returns `BinaryDocValues` for this field, or null if no binary doc values were indexed for this field.
    `ByteVectorValues` | `getByteVectorValues​(String field)` | Returns `ByteVectorValues` for this field, or null if no `ByteVectorValues` were indexed.
    `LeafReader` | `getDelegate()` | Returns the wrapped `LeafReader`.
    `FieldInfos` | `getFieldInfos()` | Get the `FieldInfos` describing all fields in this reader.
    `FloatVectorValues` | `getFloatVectorValues​(String field)` | Returns `FloatVectorValues` for this field, or null if no `FloatVectorValues` were indexed.
    `Bits` | `getLiveDocs()` | Returns the `Bits` representing live (not deleted) docs.
    `LeafMetaData` | `getMetaData()` | Return metadata about this leaf.
    `NumericDocValues` | `getNormValues​(String field)` | Returns `NumericDocValues` representing norms for this field, or null if no `NumericDocValues` were indexed.
    `NumericDocValues` | `getNumericDocValues​(String field)` | Returns `NumericDocValues` for this field, or null if no numeric doc values were indexed for this field.
    `PointValues` | `getPointValues​(String field)` | Returns the `PointValues` used for numeric or spatial searches for the given field, or null if there are no point fields.
    `SortedDocValues` | `getSortedDocValues​(String field)` | Returns `SortedDocValues` for this field, or null if no `SortedDocValues` were indexed for this field.
    `SortedNumericDocValues` | `getSortedNumericDocValues​(String field)` | Returns `SortedNumericDocValues` for this field, or null if no `SortedNumericDocValues` were indexed for this field.
    `SortedSetDocValues` | `getSortedSetDocValues​(String field)` | Returns `SortedSetDocValues` for this field, or null if no `SortedSetDocValues` were indexed for this field.
    `Fields` | `getTermVectors​(int docID)` | Retrieve term vectors for this document, or null if term vectors were not indexed.
    `int` | `maxDoc()` | Returns one greater than the largest possible document number.
    `int` | `numDocs()` | Returns the number of documents in this index.
    `void` | `searchNearestVectors​(String field, byte[] target, KnnCollector knnCollector, Bits acceptDocs)` | Return the k nearest neighbor documents as determined by comparison of their vector values for this field, to the given vector, by the field's similarity function.
    `void` | `searchNearestVectors​(String field, float[] target, KnnCollector knnCollector, Bits acceptDocs)` | Return the k nearest neighbor documents as determined by comparison of their vector values for this field, to the given vector, by the field's similarity function.
    `StoredFields` | `storedFields()` | Returns a `StoredFields` reader for the stored fields of this index.
    `Terms` | `terms​(String field)` | Returns the `Terms` index for this field, or null if it has none.
    `TermVectors` | `termVectors()` | Returns a `TermVectors` reader for the term vectors of this index.
    `String` | `toString()` |
    `static LeafReader` | `unwrap​(LeafReader reader)` | Get the wrapped instance by `reader` as long as this reader is an instance of `FilterLeafReader`.

    - ### Methods inherited from class org.apache.lucene.index.LeafReader

      `docFreq, getContext, getCoreCacheHelper, getDocCount, getSumDocFreq, getSumTotalTermFreq, postings, postings, searchNearestVectors, searchNearestVectors, totalTermFreq`

    - ### Methods inherited from class org.apache.lucene.index.IndexReader

      `close, decRef, document, document, ensureOpen, equals, getReaderCacheHelper, getRefCount, getTermVector, hasDeletions, hashCode, incRef, leaves, notifyReaderClosedListeners, numDeletedDocs, registerParentReader, tryIncRef`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### in

          protected final LeafReader in

      The underlying LeafReader.

  - ### Constructor Detail

    - #### FilterLeafReader

          protected FilterLeafReader​(LeafReader in)

      Construct a FilterLeafReader based on the specified base reader.

      Note that base reader is closed if this FilterLeafReader is closed.

      Parameters:
        `in` - specified base reader.

  - ### Method Detail

    - #### unwrap

          public static LeafReader unwrap​(LeafReader reader)

      Get the wrapped instance by `reader` as long as this reader is an instance of `FilterLeafReader`.

    - #### getLiveDocs

          public Bits getLiveDocs()

      Description copied from class: `LeafReader`
      Returns the `Bits` representing live (not deleted) docs. A set bit indicates the doc ID has not been deleted. If this method returns null it means there are no deleted documents (all documents are live).

      The returned instance has been safely published for use by multiple threads without additional synchronization.

      Specified by:
        `getLiveDocs` in class `LeafReader`

    - #### getFieldInfos

          public FieldInfos getFieldInfos()

      Description copied from class: `LeafReader`
      Get the `FieldInfos` describing all fields in this reader.

      Note: Implementations should cache the FieldInfos instance returned by this method such that subsequent calls to this method return the same instance.

      Specified by:
        `getFieldInfos` in class `LeafReader`

    - #### getPointValues

          public PointValues getPointValues​(String field)
                                     throws IOException

      Description copied from class: `LeafReader`
      Returns the `PointValues` used for numeric or spatial searches for the given field, or null if there are no point fields.
      Specified by:
        `getPointValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### getFloatVectorValues

          public FloatVectorValues getFloatVectorValues​(String field)
                                                 throws IOException

      Description copied from class: `LeafReader`
      Returns `FloatVectorValues` for this field, or null if no `FloatVectorValues` were indexed. The returned instance should only be used by a single thread.
      Specified by:
        `getFloatVectorValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### getByteVectorValues

          public ByteVectorValues getByteVectorValues​(String field)
                                               throws IOException

      Description copied from class: `LeafReader`
      Returns `ByteVectorValues` for this field, or null if no `ByteVectorValues` were indexed. The returned instance should only be used by a single thread.
      Specified by:
        `getByteVectorValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### searchNearestVectors

          public void searchNearestVectors​(String field,
                                           float[] target,
                                           KnnCollector knnCollector,
                                           Bits acceptDocs)
                                    throws IOException

      Description copied from class: `LeafReader`
      Return the k nearest neighbor documents as determined by comparison of their vector values for this field, to the given vector, by the field's similarity function. The score of each document is derived from the vector similarity in a way that ensures scores are positive and that a larger score corresponds to a higher ranking.

      The search is allowed to be approximate, meaning the results are not guaranteed to be the true k closest neighbors. For large values of k (for example when k is close to the total number of documents), the search may also retrieve fewer than k documents.

      The returned `TopDocs` will contain a `ScoreDoc` for each nearest neighbor, in order of their similarity to the query vector (decreasing scores). The `TotalHits` contains the number of documents visited during the search. If the search stopped early because it hit `visitedLimit`, it is indicated through the relation `TotalHits.Relation.GREATER_THAN_OR_EQUAL_TO`.

      The behavior is undefined if the given field doesn't have KNN vectors enabled on its `FieldInfo`. The return value is never `null`.

      Specified by:
        `searchNearestVectors` in class `LeafReader`
      Parameters:
        `field` - the vector field to search
        `target` - the vector-valued query
        `knnCollector` - collector with settings for gathering the vector results.
        `acceptDocs` - `Bits` that represents the allowed documents to match, or `null` if they are all allowed to match.
      Throws:
        `IOException`

    - #### searchNearestVectors

          public void searchNearestVectors​(String field,
                                           byte[] target,
                                           KnnCollector knnCollector,
                                           Bits acceptDocs)
                                    throws IOException

      Description copied from class: `LeafReader`
      Return the k nearest neighbor documents as determined by comparison of their vector values for this field, to the given vector, by the field's similarity function. The score of each document is derived from the vector similarity in a way that ensures scores are positive and that a larger score corresponds to a higher ranking.

      The search is allowed to be approximate, meaning the results are not guaranteed to be the true k closest neighbors. For large values of k (for example when k is close to the total number of documents), the search may also retrieve fewer than k documents.

      The returned `TopDocs` will contain a `ScoreDoc` for each nearest neighbor, in order of their similarity to the query vector (decreasing scores). The `TotalHits` contains the number of documents visited during the search. If the search stopped early because it hit `visitedLimit`, it is indicated through the relation `TotalHits.Relation.GREATER_THAN_OR_EQUAL_TO`.

      The behavior is undefined if the given field doesn't have KNN vectors enabled on its `FieldInfo`. The return value is never `null`.

      Specified by:
        `searchNearestVectors` in class `LeafReader`
      Parameters:
        `field` - the vector field to search
        `target` - the vector-valued query
        `knnCollector` - collector with settings for gathering the vector results.
        `acceptDocs` - `Bits` that represents the allowed documents to match, or `null` if they are all allowed to match.
      Throws:
        `IOException`

    - #### getTermVectors

          public Fields getTermVectors​(int docID)
                                throws IOException

      Description copied from class: `IndexReader`
      Retrieve term vectors for this document, or null if term vectors were not indexed. The returned Fields instance acts like a single-document inverted index (the docID will be 0).
      Specified by:
        `getTermVectors` in class `IndexReader`
      Throws:
        `IOException`

    - #### termVectors

          public TermVectors termVectors()
                                  throws IOException

      Description copied from class: `IndexReader`
      Returns a `TermVectors` reader for the term vectors of this index.

      This call never returns `null`, even if no term vectors were indexed. The returned instance should only be used by a single thread.

      Example:

           TopDocs hits = searcher.search(query, 10);
           TermVectors termVectors = reader.termVectors();
           for (ScoreDoc hit : hits.scoreDocs) {
             Fields vector = termVectors.get(hit.doc);
           }

      Specified by:
        `termVectors` in class `IndexReader`
      Throws:
        `IOException` - If there is a low-level IO error

    - #### numDocs

          public int numDocs()

      Description copied from class: `IndexReader`
      Returns the number of documents in this index.

      NOTE: This operation may run in O(maxDoc). Implementations that can't return this number in constant-time should cache it.

      Specified by:
        `numDocs` in class `IndexReader`

    - #### maxDoc

          public int maxDoc()

      Description copied from class: `IndexReader`
      Returns one greater than the largest possible document number. This may be used to, e.g., determine how big to allocate an array which will have an element for every document number in an index.
      Specified by:
        `maxDoc` in class `IndexReader`

    - #### storedFields

          public StoredFields storedFields()
                                    throws IOException

      Description copied from class: `IndexReader`
      Returns a `StoredFields` reader for the stored fields of this index.

      This call never returns `null`, even if no stored fields were indexed. The returned instance should only be used by a single thread.

      Example:

           TopDocs hits = searcher.search(query, 10);
           StoredFields storedFields = reader.storedFields();
           for (ScoreDoc hit : hits.scoreDocs) {
             Document doc = storedFields.document(hit.doc);
           }

      Specified by:
        `storedFields` in class `IndexReader`
      Throws:
        `IOException` - If there is a low-level IO error

    - #### document

          public void document​(int docID,
                               StoredFieldVisitor visitor)
                        throws IOException

      Description copied from class: `IndexReader`
      Expert: visits the fields of a stored document, for custom processing/loading of each field. If you simply want to load all fields, use `IndexReader.document(int)`. If you want to load a subset, use `DocumentStoredFieldVisitor`.
      Specified by:
        `document` in class `IndexReader`
      Throws:
        `IOException`

    - #### doClose

          protected void doClose()
                          throws IOException

      Description copied from class: `IndexReader`
      Implements close.
      Specified by:
        `doClose` in class `IndexReader`
      Throws:
        `IOException`

    - #### terms

          public Terms terms​(String field)
                      throws IOException

      Description copied from class: `LeafReader`
      Returns the `Terms` index for this field, or null if it has none.
      Specified by:
        `terms` in class `LeafReader`
      Throws:
        `IOException`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### getNumericDocValues

          public NumericDocValues getNumericDocValues​(String field)
                                               throws IOException

      Description copied from class: `LeafReader`
      Returns `NumericDocValues` for this field, or null if no numeric doc values were indexed for this field. The returned instance should only be used by a single thread.
      Specified by:
        `getNumericDocValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### getBinaryDocValues

          public BinaryDocValues getBinaryDocValues​(String field)
                                             throws IOException

      Description copied from class: `LeafReader`
      Returns `BinaryDocValues` for this field, or null if no binary doc values were indexed for this field. The returned instance should only be used by a single thread.
      Specified by:
        `getBinaryDocValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### getSortedDocValues

          public SortedDocValues getSortedDocValues​(String field)
                                             throws IOException

      Description copied from class: `LeafReader`
      Returns `SortedDocValues` for this field, or null if no `SortedDocValues` were indexed for this field. The returned instance should only be used by a single thread.
      Specified by:
        `getSortedDocValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### getSortedNumericDocValues

          public SortedNumericDocValues getSortedNumericDocValues​(String field)
                                                           throws IOException

      Description copied from class: `LeafReader`
      Returns `SortedNumericDocValues` for this field, or null if no `SortedNumericDocValues` were indexed for this field. The returned instance should only be used by a single thread.
      Specified by:
        `getSortedNumericDocValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### getSortedSetDocValues

          public SortedSetDocValues getSortedSetDocValues​(String field)
                                                   throws IOException

      Description copied from class: `LeafReader`
      Returns `SortedSetDocValues` for this field, or null if no `SortedSetDocValues` were indexed for this field. The returned instance should only be used by a single thread.
      Specified by:
        `getSortedSetDocValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### getNormValues

          public NumericDocValues getNormValues​(String field)
                                         throws IOException

      Description copied from class: `LeafReader`
      Returns `NumericDocValues` representing norms for this field, or null if no `NumericDocValues` were indexed. The returned instance should only be used by a single thread.
      Specified by:
        `getNormValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### getMetaData

          public LeafMetaData getMetaData()

      Description copied from class: `LeafReader`
      Return metadata about this leaf.
      Specified by:
        `getMetaData` in class `LeafReader`

    - #### checkIntegrity

          public void checkIntegrity()
                              throws IOException

      Description copied from class: `LeafReader`
      Checks consistency of this reader.

      Note that this may be costly in terms of I/O, e.g. may involve computing a checksum value against large data files.

      Specified by:
        `checkIntegrity` in class `LeafReader`
      Throws:
        `IOException`

    - #### getDelegate

          public LeafReader getDelegate()

      Returns the wrapped `LeafReader`.